#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;

require "./functions.cgi";



my $isLogin = isLoggedin();
my $user=hasCookie();

my $query;
$query = new CGI;

my $db = connecttodatabase();

#get input
my $thetext = $query->param("thetext");
my $color = $query->param("color");
my $newcolor = $query->param("ncolor");
my $isbold = $query->param("bold");
my $showdialog=1;
if($isbold){
    $isbold=1;
}
else{
    $isbold=0;
}
my $isI = $query->param("italics");
if($isI){
    $isI=1;
}
else {
    $isI=0;
}
my $isU = $query->param("underline");
if($isU){
    $isU=1;
}
else {
    $isU=0;
}


if($newcolor){
    $color=$newcolor;
}

my $setcolor=0;
if(!$color){
    if($isLogin){ #if the user didnt specify a color then get the default
	my $prefs=$db->query("select * from chatuserpreferences where userid=$user");
	my %up = $prefs->FetchHash;
	$color="$up{fontcolor}";
    }
    else {
	$color="chatdefault";
    }
}
else{
    $setcolor=1;
}

my $isLoginChat = chatLoggedIn(); #determine if the user is in chat or was booted
my $isbooted = chatBooted();




if($isLogin){
    if($thetext){
	if($isLoginChat){
	    
	    my $username=getUsername($user); #determine username
	    $thetext=cleanPost($thetext); #clean out html
	    $thetext=cleanPunctuation($thetext); #clean out punctuation for entry into db
	    my $prefs=$db->query("select * from chatuserpreferences where userid=$user");
	    my %up = $prefs->FetchHash;
	    my $namecolor=$up{namecolor};
	    if($isbold){ #add bold tags
		$thetext = "<b>" . $thetext . "</b>";
	    }
	    if($isI){ #add italics
		$thetext = "<i>" . $thetext . "</i>";
	    }
	    if($isU){ #add underline
		$thetext = "<u>" . $thetext . "</u>";
	    }
	    
	    $thetext = "<b><span class=\"$namecolor\">$username&nbsp;&nbsp;</span>~</b>&nbsp;<span class=\"$color\">" . $thetext . "</span><br>\n";
	    
	    #Updates the chatlog
	    $db->query("update chatlogs set logtext=concat('$thetext',logtext) where inuse=1");
	    $db->query("update chatusers set lastactive=now() where userid=$user");
	    
	    
	}
	else {
		#If the user is not logged in but got booted display a message
	    if($isbooted){
		
		print_html("headers");	
		print_html("stylesheet");
		print "<head>";
		print_html("javascriptvalidation");
		print "</head>";
		#Display you were removed from the chatroom
		print "<body><div align=center>You were removed from the chatroom</div>";
		print_html("endhtml");
		$showdialog=0;
	    }
	    else {
	    #If the user is not booted then display he is not logged in
		print_html("headers");
		print_html("stylesheet");
		print "<head>";
		print_html("javascriptvalidation");
		print "</head>";
		print "<body><div align=center>You are no longer logged in</div>";
		print_html("endhtml");
		$showdialog=0;
	    }	
	}
    }
	#If the dialog box should be shown
    if ($showdialog){
	print_html("headers");
	print_html("stylesheet");
	print "<head>";
	print_html("javascriptvalidation");
	print "</head>";
	print "<body onLoad=\"focusInput();\">";
	#Show dialog form
#	<textarea rows=1 cols=60 name="thetext"></textarea>

	print <<HTML;
    
    <form action="chatdialog.cgi" method=post name="cdialog">  
	<table><tr><td colspan=2 nowrap align=center>
	<input type=text name="thetext" size=52%><!--size was 56-->
	<input type=submit value="Send" ></td>
	<TD align=center><A HREF="chatpreferences.cgi" target="_blank">Settings</A></TD>

	</tr>

	
	
HTML
#If the user doesnt have a default color display this part of the page
#it sends the color as color and will overwrite the default
if (!$setcolor){
    print <<HTML;
    <tr><td>

    <table border=1><tr>

	<td nowrap>Text:
    	    

       <span class="chatcolor1bg">
	    <input type=radio value="chatcolor1" name="color">
	    </span>	
	<span class="chatcolor2bg";>
	    <input type=radio value="chatcolor2" name="color">
	    </span>
	<span class="chatcolor3bg";>
	    <input type=radio value="chatcolor3" name="color">
	    </span>
	<span class="chatcolor4bg";>
	    <input type=radio value="chatcolor4" name="color">
	    </span>
	<span class="chatcolor5bg";>
	    <input type=radio value="chatcolor5" name="color">
	    </span>
	<span class="chatcolor6bg";>
	    <input type=radio value="chatcolor6" name="color">
	    </span>
	<span class="chatcolor7bg";>
	    <input type=radio value="chatcolor7" name="color">
	    </span>
	<span class="chatcolor8bg";>
	    <input type=radio value="chatcolor8" name="color">
	    </span>
	<span class="chatcolor9bg";>
	    <input type=radio value="chatcolor9" name="color">
	    </span>
	<span class="chatcolor10bg";>
	    <input type=radio value="chatcolor10" name="color">
	    </span>

	</table>
	</td><td align=right>
	<table border=1><tr >
	<td nowrap><b>B</b>:<input type=checkbox name=bold 

HTML

	#If bold is checked
if($isbold){
    print "checked";
}
    print <<HTML;
>
	<i>I</i>:<input type=checkbox  name=italics
HTML

	#if italics is checked
if($isI){
    print "checked";
}
    print <<HTML;
>
	<u>U</u>:<input type=checkbox  name=underline
HTML

	#If underlined is checked
if($isU){
    print "checked";
}
	#Prints the view chat log button
    print <<HTML;
></td>
	
	
	</tr></table>
	</td><td align=center><a href="viewchatlogs.cgi" target="_blank">View Logs</a></td></tr>
	</table></form>
	
HTML

}
    else{
	#this part will run if the above part already sent in a color it does this in order to keep the new color setting from before as a hidden variable and change the parameter name to ncolor (new color)
	
	print <<HTML;
	<tr>	    <td>
	    <table border=1><tr><td nowrap>
	  Text:
	    <span class="chatcolor1bg">
	    <input type=radio value="chatcolor1" name="ncolor">
	    </span>	
	<span class="chatcolor2bg";>
	    <input type=radio value="chatcolor2" name="ncolor">
	    </span>
	<span class="chatcolor3bg";>
	    <input type=radio value="chatcolor3" name="ncolor">
	    </span>
	<span class="chatcolor4bg";>
	    <input type=radio value="chatcolor4" name="ncolor">
	    </span>
	<span class="chatcolor5bg";>
	    <input type=radio value="chatcolor5" name="ncolor">
	    </span>
	<span class="chatcolor6bg";>
	    <input type=radio value="chatcolor6" name="ncolor">
	    </span>
	<span class="chatcolor7bg";>
	    <input type=radio value="chatcolor7" name="ncolor">
	    </span>
	<span class="chatcolor8bg";>
	    <input type=radio value="chatcolor8" name="ncolor">
	    </span>
	<span class="chatcolor9bg";>
	    <input type=radio value="chatcolor9" name="ncolor">
	    </span>
	<span class="chatcolor10bg";>
	    <input type=radio value="chatcolor10" name="ncolor">
	    </span>
	    <input type=hidden name="color" value="$color">
	
	</table>
	    </td>
	    
	    <td  align=right>
	    <table border=1><tr>
	    <td><b>B</b>:<input type=checkbox name=bold
HTML
if($isbold){
    print "checked";
}
    print <<HTML;
>
	    <i>I</i>:<input type=checkbox  name=italics
HTML
if($isI){
    print "checked";
}
    print <<HTML;
>
	    <u>U</u>:<input type=checkbox  name=underline
HTML
if($isU){
    print "checked";
}
    print <<HTML;

></td>
	    
	    </tr>
	    </table>
	    
	    <td align=center><a href="viewchatlogs.cgi" target="_blank">View Logs</a></td></tr>
	    </table>
	    
	    </form>

HTML



print_html("endhtml");
    }
    }
}
else{
    print_html("ofcourse");
    print_html("javascriptvalidation");
    print "You arent logged in";
    
}
