#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";

my $query;
$query = new CGI;
my $isLogin = isLoggedin();
my $isAdmin = isLoggedinAdmin();
my $db=connecttodatabase();
my $user=hasCookie();


#checks if admin
if($isAdmin){
    #if they are an admin and selected to boot someone, get user's id 
    my $userid = $query->param("bootme");
    if($userid){
	#if the user is booted get their username
	my $username = getUsername($userid);
	#delete user from chatroom
	$db->query("delete from chatusers where userid=$userid");
	$db->query("update lurkerchatusers set logouttime=now() where userid=$userid and logouttime=-1");
	#get time and log time of boot in database
	my $timeres=$db->query("select now()");
	my $time=parse_time($timeres->FetchRow);
	$db->query("update chatlogs set logtext=concat('<span color=\"black\"> $time: $username was removed from chat<br></span>\n',logtext) where inuse=1");
	$db->query("insert into bootedfromchat(userid,timebooted) values($userid,now())");
	my $usersleft=$db->query("select * from chatusers");
	if($usersleft->FetchRow){
	}
	else {
	    $db->query("update chatlogs set inuse=0,endtime=now() where inuse=1");
	}
    }
}
#if user selected the "hide user info" link hide their info
my $hide = $query->param("hide");
if($hide){
    $db->query("update chatuserpreferences set dinlist=0 where userid=$user");
}
#if user selected the "show user info" link hide their info
my $show = $query->param("show");
if($show){
    $db->query("update chatuserpreferences set dinlist=1 where userid=$user");
}


my $isLoginChat = chatLoggedIn();
#if user logged in 
if($isLogin){
    print_html("headers");
    
    my $isbooted = chatBooted();
    #check if user wants extra info displayed or hidden
    my $usersps = $db->query("select dinlist from chatuserpreferences where userid=$user");
    my $displayinlist = 1;
    $displayinlist = $usersps->FetchRow;
    
    #if logged in chat
    if($isLoginChat){

    
	print <<HTML;
	<HTML><HEAD><META HTTP-EQUIV="PRAGMA" Content="NO-CACHE">
	    <META HTTP-EQUIV=Refresh Content="8;URL=chatusers.cgi">
	    
HTML

	    print_html("stylesheet");

	print "</head><body>";

#get users in chatroom from database
my $chatres=$db->query("select userid,lastactive,now() as now,logintime from chatusers order by username");
	
	print "<div align=center>";
	
#check current preference and display correct one accordingly
	if($displayinlist){
	    print "<a href=\"chatusers.cgi?hide=1\">Hide User Info</a><br>";
	}
	else {
	    print "<a href=\"chatusers.cgi?show=1\">Show User Info</a><br>";
	}
	print "<table width=100%><tr width=100%><th class=\"largercolor\" width=41%>Username&nbsp;</th><th class=\"largercolor\">Logged in<br>(minutes)</th></tr>";
	#get all usernames and and user's info 
	while(my %chat=$chatres->FetchHash){    
	    
	    
	    my $userid=$chat{userid};
	    my $username=getUsername($userid);
	    my $userinfores = $db->query("select * from users where userid=$userid");
	    my %userinfo = $userinfores->FetchHash;
	    my $firstname = $userinfo{firstname};
	    my $lastname = $userinfo{lastname};
	    my $email;
	    my $isa;
	    
	    if($userinfo{includeemail} || $isAdmin){
		$email = "Email: <a href=\"mailto:$userinfo{email}\">$userinfo{email}</a><br>";
	    }
	    if($userinfo{isadmin}){
		$isa = "This User is an Instructor<br>";
	    }
	    
	    my $chatps = $db->query("select * from chatuserpreferences where userid=$userid");
	    
	    my %prefs = $chatps->FetchHash;
	    
		    
	    
	    print "<tr width=100%>";
	    
	    print "<td colspan=2>";
	   
	    print "<table border=1 cellspacing=0 width=100%>\n";
	    print "<tr>\n";
	    #display username
	    print "<td align=center class=\"$prefs{namecolor}\" width=47%>$username</td>\n";
	    my $idletime= timeInChat($chat{lastactive},$chat{now});
	    my $minutes = timeInChat($chat{logintime},$chat{now});
	    #display the time the user has been logged in chatroom for. 
	    print "<td align=center>$minutes";
	    print"</td></tr>\n";
	    #if they want extra user info diplay it
	    if($displayinlist){
		print "<tr><td colspan=2 class=\"users\">";
		print "<span >$isa Real Name: $firstname $lastname<br>$email Idle for $idletime Min</span>"; 
		print "</td></tr>";
	    }
	    #if they are an admin
	    if ($isAdmin ){
		#get users id
		my $isadminres = $db->query("select isadmin from users where userid=$userid");
		my $isadminchat = $isadminres->FetchRow;
		#if the user is not a admin display a boot button
		if(!$isadminchat ){
		    print "<form method=post>\n";
		    print "<input type=hidden name=\"bootme\" value=$userid>";
		    print "<tr>\n";
		    print "<td align=center colspan=2><input type=submit value=\"Boot this user $chat{isadmin}\"></td>\n";
		    print "</tr></form>\n";
		}
	    }
	    
	    print "</table>";

	    print "</td></tr>";
	    #my $user=hasCookie();
	    
	    my $acdate = $chat{lastactive};
	    my $curdate = $chat{now};
	    #compares the time the user was last active to the present and if the user has been idle more than 10 minutes it returns true, then boots the user
	    if(bootChatUser($acdate,$curdate)){
		#logout user from chatroom
		$db->query("delete from chatusers where userid=$userid");
		$db->query("update lurkerchatusers set logouttime=logintime + INTERVAL 10 minute where userid=$userid and logouttime=-1");
		my $timeres=$db->query("select now()");
		my $time=parse_time($timeres->FetchRow);
		#input into chat logs the user and time they logged out
		$db->query("update chatlogs set logtext=concat('<span color=\"black\"> $time: $username left chat<br></span>\n',logtext) where inuse=1");
		
		my $usersleft=$db->query("select * from chatusers");
		#if there are users left in chatroom do nothing, if no users left in chatroom end log and record end time
		if($usersleft->FetchRow){
		}
		else {
		    $db->query("update chatlogs set inuse=0,endtime=now() where inuse=1");
		}
		
		
	    }
	    
	}
	
	print "</table></div>";
	print_html("endhtml");
    }
    else {
	#if the user was booted display this message
	if($isbooted){
	    print "<html>";
	    print "<body>";
	    print "<div align=center>You were removed from the chatroom</div>";
	    print_html("endhtml");
	    
	}
	#if not booted, but logged in. Inform user
	else {
	    print "<html>";
	    print "<body>";
	    print "<div align=center>You are not logged in</div>";
	    print_html("endhtml");
	}
    }
}
else {
    

    print "Location: login.cgi?page=chatroom.cgi";
    
}



