#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;

require "./functions.cgi";

my $db = connecttodatabase();

my $isLogin = isLoggedin();
my $userid = hasCookie();
my $isAdmin = isLoggedinAdmin();

#If the user is an admin redirect to the gradebook page because an instructor will have no grades
if($isAdmin){
   print "Location: gradebook.cgi\n\n";
}

#make sure the user is logged in
if($isLogin){

    #Get all the types
    my @foundtypes;
    my $assres = $db->query("select distinct type from grades order by type");
    while(my $assigntype = $assres->FetchRow){
	push(@foundtypes,$assigntype);
    }

    #Print the headers and stylesheet
    print_html("ofcourse");
    print_html("stylesheet");

    #Center the page
    print "<div align=center>";
    
    #Print the anchor links for each type
    foreach(@foundtypes){
	print "<A HREF=#$_>$_ </A> / ";
    }
	print "<A HREF=#onlinequiz>Online Quiz  </A>";

    #Print every type
    foreach(@foundtypes){
	#Query the database to see if the logged in user has any grades for each type
	my %test;
	my $testresult = $db->query("select comments,points,points_possible,assignname from grades where userid='$userid' and type='$_'");
	print "<A NAME=$_><H1>$_ Grades</H1></A>";	 
	
	#If the user has grades print them out
	if(%test = $testresult->FetchHash){
	    
	    print "<TABLE border =1px cellspacing=0 cellpadding=5>";
	    print "<TH class=\"blue\" width=25%>Assignment Name</TH><TH class=\"blue\" width=15%>Points Earned</TH><TH class=\"blue\" width=15%>Points possible</TH><TH class=\"blue\" width=45%>Comments</TH>";
	    my $assigname = $test{assignname};
	    my $comments = $test{comments};

	    #If there are no comments print a space so the table looks normal
	    if(!$comments){
		    $comments = '&nbsp;';
		}

	    my $points = $test{points};
	    
	    #If points is -1 then there is no grade in the database
	    if($points==-1){
		$points='No Grade';
	    }
	    my $totalpoints = $test{points_possible};
	    print "<TR><TD>$assigname<\/TD><TD>$points</TD><TD>$totalpoints</TD><TD>$comments</TD><\/TR>";
	    
	    
	    while(my %test = $testresult->FetchHash){
		$assigname = $test{assignname};
		$comments = $test{comments};
		#If there are no comments print a space so the table looks normal
		if(!$comments){
		    $comments = '&nbsp;';
		}
		
		#If points is -1 then there is no grade in the database
		$points = $test{points};
		if($points==-1){
		    $points='No Grade';
		}
		$totalpoints = $test{points_possible};
		print "<TR><TD>$assigname<\/TD><TD>$points</TD><TD>$totalpoints</TD><TD>$comments</TD><\/TR>";
		
	    }
	    print "</TABLE>";
	    print "<HR>";
	}
	#If there are no grades print that there are no grades
	else{
	    print "<DIV align=center>";
	    print "<H2>You have no $_ grades.</H2> </DIV>";
	    print "<HR>";
	}
    }
    #Print off the grades for hte online quiz
    print "<A NAME=onlinequiz><H1>Online Quiz  Grades</H1></A>";
    my %test;
    my $testresult = $db->query("select test_id,points,points_possible from results where userid='$userid'");
    if(%test = $testresult->FetchHash){
	print "<TABLE border =1px cellspacing=0 cellpadding=5>";
	print "<TH class=\"blue\" width=25%>Assignment Name</TH><TH class=\"blue\" width=15%>Points Earned</TH><TH class=\"blue\" width=15%>Points possible</TH><TH class=\"blue\" width=45%>Comments</TH>";
	my $assigname = $test{test_id};
	my $points = $test{points};
	my $totalpoints = $test{points_possible};
	print "<TR><TD>$assigname<\/TD><TD>$points</TD><TD>$totalpoints</TD><TD>&nbsp;</TD><\/TR>";
	while(%test = $testresult->FetchHash){
	    $assigname = $test{test_id};
	    $points = $test{points};
	    if($points==-1){
		$points='No Grade';
	    }
	    $totalpoints = $test{points_possible};
	    print "<TR><TD>$assigname<\/TD><TD>$points</TD><TD>$totalpoints</TD><TD>&nbsp;</TD><\/TR>";
	    
	}
	print "</TABLE>";
    }
    #If there are no grades print that there are no grades
    else{
	print "<DIV align=center>";
	print "<H2>You have no online quiz grades.</H2> </DIV>";
    }
    
    #Print blank lines to get the anchors to work properly
    print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>";
    #end the html
    print_html("endhtml");

}
#redirect to the login page if the user is not logged in
else {
    print "Location: login.cgi?page=checkgrade.cgi\n\n";
}



