#!pathtoperl -w


require ("./functions.cgi");
#These are your default settings which can be restored from the 
#look and feel page.

#Changes made to look and feel will not affect the default settings.



#this varible controls the background color for all pages
my $bodyBackgroundColor="\#ffffff";  

#this varible controls the text color for all pages
my $textColor="\#111111";            

#this varible controls the link color for all pages
my $linkColor="\#0000cc";

#this will be the color of the link when the person puts the mouse over it
my $hoverLinkColor="\#0000ff";

#this will be the color of the larger text (used in <h1> and a few other cases)
my $largerTextColor="\#000000";

#The background color of the header for each post in the discussion board
my $discussionBoardPostHeaderColor="\#b8b8b8";

#the background color when there is a new post in the discussion board
my $newPostBackgroundColor="\#ffff66";

#the background color when there arent any new posts in the discussion board
my $oldPostBackgroundColor="\#dddddd";


#colors for the chatroom
my $color1 = "\#000000";
my $color2 = "\#ff0000";
my $color3 = "\#ffcc00";
my $color4 = "\#0000ff";
my $color5 = "\#009933";
my $color6 = "\#9900cc";
my $color7 = "\#ff9900";
my $color8 = "\#ff00ff";
my $color9 = "\#cc9933";
my $color10 = "\#3399ff";
my $buttonImage = "buttons/blackbg.gif";
my $db=connecttodatabase();


my $sres=$db->query("select * from cssSettings");
my %ci = getCourseInfo();
if(($ci{buttonchoice} ne "default")&&($ci{buttonchoice} ne "none")){
    $buttonImage = "buttons/" . $ci{buttonchoice};

}

my $buttoncolorchoiceBG = $ci{buttoncolorchoice};
my $buttontextcolor = $ci{buttontextcolor};

if(my %settings=$sres->FetchHash){
    $bodyBackgroundColor=$settings{bodyBackgroundColor};  
    $textColor=$settings{textColor};
    $linkColor=$settings{linkColor};
    $hoverLinkColor=$settings{hoverLinkColor};
    $largerTextColor=$settings{largerTextColor};
    $discussionBoardPostHeaderColor=$settings{discussionBoardPostHeaderColor};
    $newPostBackgroundColor=$settings{newPostBackgroundColor};
    $oldPostBackgroundColor=$settings{oldPostBackgroundColor};
    $color1 = $settings{color1};
    $color2 = $settings{color2};
    $color3 = $settings{color3};
    $color4 = $settings{color4};
    $color5 = $settings{color5};
    $color6 = $settings{color6};
    $color7 = $settings{color7};
    $color8 = $settings{color8};
    $color9 = $settings{color9};
    $color10 =$settings{color10};
    
}
else {
    $db->query("insert into cssSettings(bodyBackgroundColor,textColor,linkColor,hoverLinkColor,largerTextColor,discussionBoardPostHeaderColor,newPostBackgroundColor,oldPostBackgroundColor,color1,color2,color3,color4,color5,color6,color7,color8,color9,color10) values('$bodyBackgroundColor','$textColor','$linkColor','$hoverLinkColor','$largerTextColor','$discussionBoardPostHeaderColor','$newPostBackgroundColor','$oldPostBackgroundColor','$color1','$color2','$color3','$color4','$color5','$color6','$color7','$color8','$color9','$color10')");
    



}




##################################
### NEVER EDIT BELOW THIS LINE ###
##################################


print "Content-type: text/css\n\n";
print <<CSS;


/* page settings */


body 	{	
	background-color: $bodyBackgroundColor;
	color: $textColor;

	}
table {
	color: $textColor;
	font: bold;
	}

ul {
list-style-type: none;

}




.toplevelbutton{
  
    font-size: 13px;
  color: $buttontextcolor; 
CSS
    if($ci{buttonchoice} ne "none"){
	print <<HTML;
	width: 110px; 
      height: 32px;
	background-image: url($buttonImage);
	background-repeat: no-repeat;
    
HTML
    
}
    else {
print <<HTML;  

 width: 12%; 
 height: 32px;
background-color: $buttoncolorchoiceBG;

HTML
    
}
    print <<CSS;
}
    .toplevelbutton a{
      color: $buttontextcolor;  
    }
    .toplevelbutton a:hover{
      color: $buttontextcolor;
	text-decoration:none;
    }

.largercolor{
  color: $largerTextColor;
}
a{ 
	color: $linkColor;
	text-decoration: none;
}

a:hover { color: $hoverLinkColor;
	  text-decoration: underline;
}

.bigger{	
	font-weight: bold;		
	font-size: 175%;
      color: $largerTextColor;
}

th.blue {
        color: $largerTextColor;
       	font-size: 100%;
}	

h1 {
	font-size: 200%;
	color: $largerTextColor;
       
}
h2 {
    font-size: 150%;
  color: $largerTextColor;
    

}


.users{
  background: #ffff99;
  top: 0px;
  left: 0px;
  padding: 0px 5px; 
  right: 0px;
  border: 1px dashed brown;
    z-index: 100; 
}


.newpost {
	width: 100%;
	color: black;
	
}

.newpost th {	
	text-align: left;
	align: left;
	background-color:$discussionBoardPostHeaderColor;
}	
.newpost td {
	background-color:$newPostBackgroundColor;	
}

.poll {
	

}
.poll td{
background-color:$oldPostBackgroundColor;


}

.oldpost {
	width: 100%;	
	color:black;
}
.oldpost th{
	text-align: left;
	align: left;
	background-color:$discussionBoardPostHeaderColor;
}
.oldpost td{
	background-color:$oldPostBackgroundColor;

}
.postcomments {
	border-bottom: 1px solid $discussionBoardPostHeaderColor;
}


.standardButton {
	width: 175px;
	

}

.poll {
	background-color:$oldPostBackgroundColor;


}
.poll td{
background-color:$oldPostBackgroundColor;


}


.hasnew {
	background-color: $newPostBackgroundColor;


}

.verticaltext {
    writing-mode: tb-rl; filter: flipH() flipV(); 
}

.nonew {
    
}

.chatwindow{
  position:absolute;
  width: 74%;
  height: 70%;
  top: 2%;
  left:1%;

    
}

.chatusers{
  position:absolute;
  width: 22%;
  height:80%;
  top:17%;
  right: 1%;
  align:center;
}

.chatdialog{
  position:absolute;
  width:74%;
  height:22%;
  bottom:2%;
  left:1%;

}

.chatwelcome{
  position:absolute;
  width:21%;
  height:10%;
  top:2%;
  right:2%;
  color: $largerTextColor;
    font-weight: bold;		
    font-size: 150%;
    text-align:center;
}

.chatcolor1{
  color: $color1;
}
.chatcolor2{
  color: $color2;
}
.chatcolor3{
  color: $color3;
}
.chatcolor4{
  color: $color4;
}
.chatcolor5{
  color: $color5;
}
.chatcolor6{
  color: $color6;
}
.chatcolor7{
  color: $color7;
}
.chatcolor8{
  color: $color8;
}
.chatcolor9{
  color: $color9;
}
.chatcolor10{
  color: $color10;
}
.chatdefault{
  color: \#000000;
}

.chatcolor1bg{
  background-color: $color1;
}
.chatcolor2bg{
  background-color: $color2;
}
.chatcolor3bg{
  background-color: $color3;
}
.chatcolor4bg{
   background-color: $color4;
}
.chatcolor5bg{
   background-color: $color5;
}
.chatcolor6bg{
   background-color: $color6;
}
.chatcolor7bg{
   background-color: $color7;
}
.chatcolor8bg{
   background-color: $color8;
}
.chatcolor9bg{
   background-color: $color9;
}
.chatcolor10bg{
   background-color: $color10;
}


CSS


if($ENV{HTTP_USER_AGENT} =~ /MSIE/){ #If the browser is IE this gets printed and fixes some problems
    print <<CSS;
    .ouruls {
      width:100%;
    }
    
    .mainbuttons{
      position: absolute;
      top: 3px;
      left: 1%;
      width: 100%;
    }
    .iframelocation{
      position: absolute;
      top:39px;
      left: 1%;
      width: 99%;
      height:90%;

    }

CSS

}
else {
    print <<CSS;
    .iframelocation{
      position: absolute;
      top:39px;
      left: 1%;
      width: 98%;
      height:90%; 
	background-color: #ffffff;
    }

    .mainbuttons{
      position: absolute;
      top: 3px;
      left: 1%;
      width: 800px;
    }
CSS

}
