#!pathtoperl   -T


use strict;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;


require "./functions.cgi";

my$query;
$query = new CGI;


my $db = connecttodatabase();



my $isAdmin = isLoggedinAdmin();

my @foundtypes;

my $assres = $db->query("select distinct type from grades");
while(my $assigntype = $assres->FetchRow){
    push(@foundtypes,$assigntype);
}

#checks if administrator
if($isAdmin){
    #get the desired assignment id
    my $assignid=$query->param("assignid");
    


    print_html("ofcourse");
    print_html("stylesheet");
    print "<div align=center>";
    #if no assignment id
    if(!$assignid){
	
	print "<table border=1 cellpadding=5 cellspacing=0>";
	#get assignment names and ids from database
	my $gradenamesresult=$db->query("select distinct assignname,assignid from grades");
	#print out field labels vertically
	print "<tr><th class=\"verticaltext\">Lastname</th><th class=\"verticaltext\">Firstname</th><th class=\"verticaltext\">Username</th>";
	my $gcount=0;
	
	my @assids;

	#while there are more assignments 
	while(my %gradelist=$gradenamesresult->FetchHash){
	    push(@assids,$gradelist{assignid});
	    #get the assignment name
	    my $assname=$gradelist{assignname};
	    #display it vertically as labels of a column
	    print "<th class=\"verticaltext\" nowrap>$assname</th>";
	    $gcount++;

	}
	#get all info on all approved regular users from database
	my $usersresult=$db->query("select * from users where isadmin=0 and isapproved=1 order by lastname");
	
	#while there are more users 
	while(my %user=$usersresult->FetchHash){
	    
	    #get users info
	    my $username=$user{username};
	    my $lastname=$user{lastname};
	    my $firstname=$user{firstname};
	    my $userid=$user{userid};
	    
            #print it out in a row
	    print "<tr>";
	    print "<td>$lastname</td>";
	    print "<td>$firstname</td>";
	    print "<td>$username</td>";
	    
	    foreach (@assids){

		
		#get point value of grades of assignment
		my $gradesresult=$db->query("select points from grades where assignid=$_ and userid=$userid");
		
	    
		
		if(my %grades=$gradesresult->FetchHash){
		    #check that there is a grade
		    my $gs = $grades{points};
		    if((!$gs || $gs==-1 )&& $gs!=0){
			$gs="&nbsp";
		    }
		    
		    
		    print "<td align=center>$gs</td>";
		    
		}
		else {
		    print "<td align=center>&nbsp;</td>";
		}
	    }
	    
	    

	}
	
	
	
    }
    else {

	
	
	my $type;
	
	my $usersres=$db->query("select userid from users where isadmin!=1 and isapproved=1");
		
	
	my $assignres=$db->query("select * from grades,users where grades.userid=users.userid and assignid=$assignid order by users.lastname");
	my $assigninfo=$db->query("select distinct assignname,points_possible from grades where assignid=$assignid");
	
	my %assinfo=$assigninfo->FetchHash;
	my $posspoints=$assinfo{points_possible};
	print "<table border=1 cellpadding=5 cellspacing=0><tr><th>Assignment Name:</th>";
	print "<td>$assinfo{assignname}</td></tr>";
	print "<th>Possible points for<br>this assignment:</th><td align=center>$posspoints</td></tr></table>";
	print "<br><br>";
	print "<table cellpadding=5 cellspacing=0 border=1><tr><th>Lastname</th><th>Firstname</th><th>Username</th>";
	
	print "<th>Points Earned</th>";
	print "<th width=45%>Comments</th>";
	
	print "</tr>";
	
	
	
	while(my %user = $assignres->FetchHash){
	    $type = $user{type};
	    my $usersinfo = $db->query("select * from users where userid=$user{userid}");
	    my %info=$usersinfo->FetchHash;
	    
	    my $score=$user{points};
	    if ($score == -1){
		$score = "&nbsp;";
	    }
	    
	    print "<tr>";
	    print "<td align=left>$info{lastname}</td>";
	    print "<td align=left>$info{firstname}</td>";
	    print "<td align=left>$info{username}</td>";
	    
	    
	    print "<td align=center>$score</td>";
	    print "<td align=center>$user{comments}&nbsp;</td>";

	    print "</tr>";
	    
	}	

	print "</table>";
	


    }
}
else {
    print "Location: login.cgi?gradebook.cgi\n\n";
    
}
