
//Takes in a string
//returns true if the string is not empty false otherwise

function isEmpty ( string ) {var res = string.search( /^\s*$/ );
    if ( res < 0 ) return false;
    return true;
}

//Takes in two strings
//returns true if they are the same string false otherwise

function stringsSame (string1, string2) {
    if (string1 == string2 ) return true;
    return false;
}

/*\\Takes in two values from a form
\\Makes sure that neither one is empty
\\If neither one is empty will check to see if they are the same
\\returns true if both are not empty and they are the same
returns false otherwise
*/

function verifyPasswords () {
    var form = document.register;
    var password1 = form.password.value;
    var password2 = form.cpassword.value;
    if (!isEmpty(password1) && !isEmpty(password2) && 
	stringsSame(password1,password2) )
	return true;
    else {
	alert("passwords did not match.\n" +
	      "Please, make sure both passwords are the same");
	form.password.focus();
	form.cpassword.select();
	return false;
    }
}

//takes in a variable from a form
//makes sure the length is greater than 4
//makes sure the string consists of letters and numbers
//returns true if the above is correct false otherwise

function validUsername() {
    var form = document.register;
    var user = form.username.value;
    if ((user.length < 4) || (user.length > 10)) {
    alert("Usernames must be between 4 and 10 characters long.");
	return false;
    }
    if (!isEmpty(user)) {
        var res = user.search(/^[a-zA-Z1-9]+$/);
        if (res >= 0 ){
           return true;
        } 
        else {
            alert("User name must only contain letters from a-z"); 
            form.username.focus();
            form.username.select();
            return false;
           
        }
    }
    else {
        alert("Please enter a user name");
        form.login.focus();
        form.login.select();
        return false;
    }
}

//Checks to make sure that first name and last names are only letters

function namefields(){
   var form = document.register;
   var first = form.firstname.value;
   var last = form.lastname.value;
   var fres = first.search(/^[a-zA-Z]+$/);
   var lres = last.search(/^[a-zA-Z]+$/);
   if (isEmpty(first)){
     alert("Please enter your first name");
     form.firstname.focus();
     form.firstname.select();
     return false;
   }
   
   if (isEmpty(last)){
     alert("Please enter your last name");
     form.lastname.focus();
     form.lastname.select();
     return false;
   }
   if( fres >= 0 && lres >= 0 ) {
      return true;
   }   
   else {
      alert("Names can only be a-z");
      if ( fres < 0 ){
        form.firstname.focus();
        form.firstname.select();
        return false;
      }
      else {
        form.lastname.focus();
        form.lastname.select();
        return false;
      }
   }

}

//makes sure an email is in the correct form

function email(){
   var form = document.register;
   var email = form.email.value;
   var res = email.search(/^.+?\@.+?\..+$/);
   if (res >= 0 ){
     return true;
   }
   else {
     alert("Email must be in form user@some.domain");
     form.email.focus();
     form.email.select();
     return false;   
   }
}

//makes sure name fields, email, usernames, and passwords match when they register

function checkdata(){
if (namefields() && email() && validUsername() && verifyPasswords() )
    return true;

    return false;
}

//makes sure name fields, and emails  match when they modify there data

function checkmodifydata(){
if (namefields() && email())
    return true;

    return false;
}


//Makes sure all fields are filled in when creating a thread

function discussionData(){
 
  var form = document.discussion;
  var comment = form.comments.value
  var name = form.threadname.value
 if(!isEmpty(comment) && !isEmpty(name)){
   return true;
 }
 else{
   alert("Please fill out both fields");
   return false;

}
}

//Makes sure that all fields are filled in when replying

function addnewpostData(){
  var form = document.newpost;
  var name = form.postname.value
  var comment = form.comments.value
 if(!isEmpty(comment) && !isEmpty(name)){
   return true;
 }
 else{
   alert("Please fill out both fields");
   return false;

}
}

//Makes sure the admin fills in the topic
function topicData(){
  var form = document.addtopic;
  var name = form.topic.value
 if(!isEmpty(name)){
   return true;
 }
 else{
   alert("Please enter a topic name!");
   return false;

}
}

//Confirms delete

function confirmDelete(){
     if(confirm('Are you sure you want to delete this?')){
         return true;
     }
     else{
         return false;
     }
}

function focusInput(){
	
	document.cdialog.thetext.focus();

}